Attribute VB_Name = "Utility Functions"
Option Compare Database
Option Explicit
Declare Function ShellExecute Lib "shell32.dll" Alias _
    "ShellExecuteA" (ByVal hWnd As Long, ByVal lpOperation As String, ByVal lpFile As String, lpParameters As String, _
    ByVal lpDirectory As String, ByVal nShowCMd As Long) As Long

Declare Function apiShellExecute Lib "shell32.dll" _
    Alias "ShellExecuteA" _
    (ByVal hWnd As Long, _
    ByVal lpOperation As String, _
    ByVal lpFile As String, _
    ByVal lpParameters As String, _
    ByVal lpDirectory As String, _
    ByVal nShowCMd As Long) _
    As Long

'***App Window Constants***
Public Const WIN_NORMAL = 1         'Open Normal
Public Const WIN_MAX = 3            'Open Maximized
Public Const WIN_MIN = 2            'Open Minimized

'***Error Codes***
Private Const ERROR_SUCCESS = 32&
Private Const ERROR_NO_ASSOC = 31&
Private Const ERROR_OUT_OF_MEM = 0&
Private Const ERROR_FILE_NOT_FOUND = 2&
Private Const ERROR_PATH_NOT_FOUND = 3&
Private Const ERROR_BAD_FORMAT = 11&
Global Const SW_SHOWNORMAL = 1

Function fHandleFile(stFile As String, lShowHow As Long)
Dim lRet As Long, varTaskID As Variant
Dim stRet As String
    'First try ShellExecute
    lRet = apiShellExecute(hWndAccessApp, vbNullString, _
            stFile, vbNullString, vbNullString, lShowHow)
            
    If lRet > ERROR_SUCCESS Then
        stRet = vbNullString
        lRet = -1
    Else
        Select Case lRet
            Case ERROR_NO_ASSOC:
                'Try the OpenWith dialog
                varTaskID = Shell("rundll32.exe shell32.dll,OpenAs_RunDLL " _
                        & stFile, WIN_NORMAL)
                lRet = (varTaskID <> 0)
            Case ERROR_OUT_OF_MEM:
                stRet = "Error: Out of Memory/Resources. Couldn't Execute!"
            Case ERROR_FILE_NOT_FOUND:
                stRet = "Error: File not found.  Couldn't Execute!"
            Case ERROR_PATH_NOT_FOUND:
                stRet = "Error: Path not found. Couldn't Execute!"
            Case ERROR_BAD_FORMAT:
                stRet = "Error:  Bad File Format. Couldn't Execute!"
            Case Else:
        End Select
    End If
    fHandleFile = lRet & _
                IIf(stRet = "", vbNullString, ", " & stRet)
End Function
Public Sub BubbleSort(ToSort As Variant, Optional SortAscending As Boolean = True)
    ' Chris Rae's VBA Code Archive - http://chrisrae.com/vba
    ' By Chris Rae, 19/5/99. My thanks to
    ' Will Rickards and Roemer Lievaart
    ' for some fixes.
    
    'modified by Vlad Cucinschi on May 12 , 2004 to sort a three dimensional array
    
    Dim AnyChanges As Boolean
    Dim BubbleSort As Long
    Dim Swap1D As Variant, Swap2D As Variant, Swap3D As Variant
    Do
        AnyChanges = False
        For BubbleSort = LBound(ToSort, 2) To UBound(ToSort, 2) - 1
            If (ToSort(0, BubbleSort) > ToSort(0, BubbleSort + 1) And SortAscending) _
               Or (ToSort(0, BubbleSort) < ToSort(0, BubbleSort + 1) And Not SortAscending) Then
                ' These two need to be swapped
                Swap1D = ToSort(0, BubbleSort)
                Swap2D = ToSort(1, BubbleSort)
                Swap3D = ToSort(2, BubbleSort)
                
                ToSort(0, BubbleSort) = ToSort(0, BubbleSort + 1)
                ToSort(1, BubbleSort) = ToSort(1, BubbleSort + 1)
                ToSort(2, BubbleSort) = ToSort(2, BubbleSort + 1)
                
                ToSort(0, BubbleSort + 1) = Swap1D
                ToSort(1, BubbleSort + 1) = Swap2D
                ToSort(2, BubbleSort + 1) = Swap3D
                AnyChanges = True
                
            End If
        Next BubbleSort
    Loop Until Not AnyChanges
End Sub
Public Function isOpen(ByVal strFormName As String) As Boolean
On Error Resume Next
'=======================
'creates IsOpen function
'=======================
Const conDesignView = 0
Const conObjStateClosed = 0
isOpen = False
If SysCmd(acSysCmdGetObjectState, acForm, strFormName) <> conObjStateClosed Then
    If Forms(strFormName).CurrentView <> conDesignView Then
        isOpen = True
       
    End If
End If
End Function
Public Function Round(x) '
' Rounds a number to 2 decimal places
' Uses arithmatic rounding
'
'Round = Int(4 * x + 0.5) / 4 'rounds to .25

  Round = Int(x * 100 + 0.5) / 100
End Function
Public Function Min2(a As Variant, b As Variant) As Variant
'
' Returns the lesser of 2 values
'
  Min2 = IIf(a < b, a, b)
End Function
Public Function Max2(a As Variant, b As Variant) As Variant
'
' Returns the greater of 2 values
'
  Max2 = IIf(a > b, a, b)
End Function
Function IsLoaded(ByVal strFormName As String) As Boolean
 ' Returns True if the specified form is open in Form view or Datasheet view.
    
    Const conObjStateClosed = 0
    Const conDesignView = 0
    
    If SysCmd(acSysCmdGetObjectState, acForm, strFormName) <> conObjStateClosed Then
        If Forms(strFormName).CurrentView <> conDesignView Then
            IsLoaded = True
        End If
    End If
    
End Function

Public Sub SET_LINKS()
Dim strPath As String, strTable As String, strLocalName As String
Dim rstPath As Recordset, rstTables As Recordset

Set rstTables = CurrentDb.OpenRecordset("hlpTABLES", dbOpenDynaset)

If rstTables.BOF And rstTables.EOF Then
MsgBox "PLEASE SELECT THE TABLES TO BE LINKED!", vbCritical, "NO TABLES!"
Exit Sub
End If
'get the path
Set rstPath = CurrentDb.OpenRecordset("hlpSettings", dbOpenDynaset)
If rstPath.RecordCount = 0 Then
    Form_frmMain.txtBE_Path_DblClick (False)
    Exit Sub
Exit Sub
End If
strPath = rstPath("PATH_TO_FILES")
'loop and link
    Do Until rstTables.EOF
        strTable = rstTables("TABLE_NAME")
        strLocalName = rstTables("LOCAL_NAME")
        If Not ObjectExists("Table", strTable) Then
            LINK_TABLES strPath, strTable, strLocalName
        End If
        rstTables.MoveNext
    Loop

End Sub
Public Sub LINK_TABLES(path As String, table As String, LOCAL_NAME As String)
'On Error Resume Next
DoCmd.TransferDatabase acLink, "Microsoft Access", path, acTable, table, LOCAL_NAME
End Sub
Public Sub BREAK_LINKS()
Dim tdf As TableDef, db As Database

Set db = CurrentDb
    For Each tdf In db.TableDefs
         If Len(tdf.Connect) > 0 Then
               DoCmd.DeleteObject acTable, tdf.Name
         End If
    Next tdf
End Sub
Public Function vvcLINK_EXISTS() As Boolean
Dim rstTables As Recordset, strTable As String
vvcLINK_EXISTS = False
Set rstTables = CurrentDb.OpenRecordset("hlpTABLES", dbOpenSnapshot)
If rstTables.RecordCount = 0 Then
    vvcLINK_EXISTS = False: Exit Function
Else
    strTable = rstTables("LOCAL_NAME")
End If
If ObjectExists("Table", strTable) Then
    vvcLINK_EXISTS = True
Else
    vvcLINK_EXISTS = False
End If
rstTables.Close
Set rstTables = Nothing
End Function
Public Sub vvcDETECT_IDDLE()
If Not vvcLINK_EXISTS Then SET_LINKS
End Sub

Function ObjectExists(strObjectType As String, strObjectName As String) As Boolean
' Pass the Object type: Table, Query, Form, Report, Macro, or Module
' Pass the Object Name
    Dim db As Database
     Dim tbl As TableDef
     Dim qry As QueryDef
     Dim i As Integer
     
     Set db = CurrentDb()
     ObjectExists = False
     
     If strObjectType = "Table" Then
          For Each tbl In db.TableDefs
               If tbl.Name = strObjectName Then
                    ObjectExists = True
                    Exit Function
               End If
          Next tbl
     ElseIf strObjectType = "Query" Then
          For Each qry In db.QueryDefs
               If qry.Name = strObjectName Then
                    ObjectExists = True
                    Exit Function
               End If
          Next qry
     ElseIf strObjectType = "Form" Or strObjectType = "Report" Or strObjectType = "Module" Then
          For i = 0 To db.Containers(strObjectType & "s").Documents.Count - 1
               If db.Containers(strObjectType & "s").Documents(i).Name = strObjectName Then
                    ObjectExists = True
                    Exit Function
               End If
          Next i
     ElseIf strObjectType = "Macro" Then
          For i = 0 To db.Containers("Scripts").Documents.Count - 1
               If db.Containers("Scripts").Documents(i).Name = strObjectName Then
                    ObjectExists = True
                    Exit Function
               End If
          Next i
     Else
          MsgBox "Invalid Object Type passed, must be Table, Query, Form, Report, Macro, or Module"
     End If
     
End Function
Public Sub StartDoc(docname As String, strFilePath As String)
Dim varShell As Variant
On Error GoTo StartDoc_Error

varShell = ShellExecute(Application.hWndAccessApp, "Open", docname, "", strFilePath, SW_SHOWNORMAL)

Exit Sub


StartDoc_Error:
MsgBox Err.Number & " " & Err.Description
Exit Sub
End Sub
Public Function StripLast(path As String) As String
    Dim x As Long
    Dim y As Long
    y = Len(path) + 1
    x = 1
    x = InStr(x, path, "\", vbDatabaseCompare)
    Do While x > 0
        y = x
        x = InStr(x + 1, path, "\")
    Loop
    StripLast = Right(path, Len(path) - y)
End Function
Public Function DirExists(strDir As String) As Boolean
  ' Comments  : Determines if the named directory exists
  ' Parameters: strDir - Directory to check
  ' Returns   : True if the directory exists, False otherwise
  ' Source    : Total Visual SourceBook 2000
  '
  On Error GoTo PROC_ERR

  DirExists = Len(Dir$(strDir & "\.", vbDirectory)) > 0
  
PROC_EXIT:
  Exit Function
  
PROC_ERR:
  MsgBox "Error: " & Err.Number & ". " & Err.Description, , _
    "DirExists"
  Resume PROC_EXIT
  
End Function
Public Function CopyFile( _
  strSource As String, _
  strDestination As String) _
  As Boolean
  ' Comments  : Copies a file
  ' Parameters: strSource - Source file
  '             strDestination - Destination file
  ' Returns   : True if successful, False otherwise
  ' Source    : Total Visual SourceBook 2000
  '
  Const cintBufferSize = 4096
  Dim strBuffer As String * cintBufferSize
  Dim strTempBuffer As String
  Dim intSourceFile As Integer
  Dim intDestinationFile As Integer
  Dim lngCounter As Long

  On Error GoTo PROC_ERR
  
  ' Open the input file, use readonly mode to avoid placing locks.
  intSourceFile = FreeFile
  Open strSource For Binary Access Read As #intSourceFile
  
  ' Open the output file
  intDestinationFile = FreeFile
  Open strDestination For Binary As #intDestinationFile
  
  ' Go through the file, a buffer at a time
  For lngCounter = 1 To LOF(intSourceFile) \ cintBufferSize
    Get #intSourceFile, , strBuffer
    Put #intDestinationFile, , strBuffer
  Next lngCounter
  
  ' Check for buffer overruns
  lngCounter = LOF(intSourceFile) Mod cintBufferSize
  
  ' Do the remainder
  If lngCounter > 0 Then
    Get #intSourceFile, , strBuffer
    strTempBuffer = Left$(strBuffer, lngCounter)
    Put #intDestinationFile, , strTempBuffer
  End If

  ' Close and clean up
  Close #intSourceFile
  Close #intDestinationFile
  CopyFile = True
  
PROC_EXIT:
  Exit Function
  
PROC_ERR:
  MsgBox "Error: " & Err.Number & ". " & Err.Description, , _
    "CopyFile"
  Resume PROC_EXIT
  
End Function
Public Function vcGetMAPIFolder(strFolderPath As String) As Object
  ' folder path needs to be something like
  '   "Public Folders\All Public Folders\Company\Sales"
  Dim objApp As Object
  Dim objNS As Object
  Dim colFolders As Object
  Dim objFolder As Object
  Dim arrFolders() As String
  Dim i As Long
  On Error Resume Next

  strFolderPath = Replace(strFolderPath, "/", "\")
  arrFolders() = Split(strFolderPath, "\")
  Set objApp = CreateObject("Outlook.Application")
  Set objNS = objApp.GetNamespace("MAPI")
  Set objFolder = objNS.Folders.Item(arrFolders(0))
  If Not objFolder Is Nothing Then
    For i = 1 To UBound(arrFolders)
      Set colFolders = objFolder.Folders
      Set objFolder = Nothing
      Set objFolder = colFolders.Item(arrFolders(i))
      If objFolder Is Nothing Then
        Exit For
      End If
    Next
  End If

  Set vcGetMAPIFolder = objFolder
  Set colFolders = Nothing
  Set objNS = Nothing
  Set objApp = Nothing
End Function

